﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;
using KBA.Helpers;
using Styx.Common;
namespace KBA.GUI
{
    public partial class ConfigForm : Form
    {
        DataSet _data = new DataSet("BuffList");
        public ConfigForm()
        {
            InitializeComponent();
            string IconToLoad = "";
            try
            {
                IconToLoad = string.Format("{0}\\Plugins\\KBA\\Images\\spell.png", Utilities.AssemblyDirectory);
                if (File.Exists(IconToLoad))
                    pbSpell.Image = new Bitmap(IconToLoad);
                IconToLoad = string.Format("{0}\\Plugins\\KBA\\Images\\potion.png", Utilities.AssemblyDirectory);
                if (File.Exists(IconToLoad))
                    pbPotion.Image = new Bitmap(IconToLoad);
                IconToLoad = string.Format("{0}\\Plugins\\KBA\\Images\\item.png", Utilities.AssemblyDirectory);
                if (File.Exists(IconToLoad))
                    pbItem.Image = new Bitmap(IconToLoad);
            }
            catch (Exception ex)
            {
                Logger.DebugLog(ex.ToString());
            }
        }

        private void ConfigForm_Load(object sender, EventArgs e)
        {           
            if (!File.Exists(KeepBuffActive.XmlPath))
            {
                //create default table
                DataTable table = new DataTable();
                table.TableName = "BuffList";
                table.Columns.Add("Description", typeof(string));
                table.Columns.Add("ItemName", typeof(string));
                table.Columns.Add("ItemId", typeof(int));
                table.Columns.Add("BuffName", typeof(string));
                table.Columns.Add("BuffId", typeof(int));
                table.Columns.Add("active", typeof(bool));
                //create default data
                table.Rows.Add("Potion of Luck", "Potion of Luck", 93351, "Potion of Luck",135855, false);
                _data.Tables.Add(table);
                Logger.InfoLog("Created default data");
            }
            else
            { 
                //load user xml
                _data.ReadXml(KeepBuffActive.XmlPath);
                Logger.InfoLog("Loaded data from xml-file");
            }
            dgBufflist.DataSource = _data;
            dgBufflist.DataMember = "BuffList";
        }
        protected override void OnClosing(CancelEventArgs e)
        {
            //save and close
            _data = (DataSet)dgBufflist.DataSource;
            _data.WriteXml(KeepBuffActive.XmlPath);
            KeepBuffActive._data = _data;
            base.OnClosing(e);
        }

        private void btnClose_Click(object sender, EventArgs e)
        {
            //save and close
            _data = (DataSet)dgBufflist.DataSource;
            _data.WriteXml(KeepBuffActive.XmlPath);
            KeepBuffActive._data = _data;
            base.Close();
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            _data = (DataSet)dgBufflist.DataSource;
            _data.WriteXml(KeepBuffActive.XmlPath);
            KeepBuffActive._data = _data;
        }

        private void btnLoad_Click(object sender, EventArgs e)
        {
            //load new datatable
        }
    }
}
